2023-03-22 10:00:09

输出到stderr的echo

是否有一个标准的Bash工具,其行为类似于echo,但输出到stderr而不是stdout?

我知道我可以做echo foo 1>&2,但它有点难看,而且,我怀疑,容易出错(例如,当事情发生变化时,更容易编辑错误)。


当前回答

你可以这样做,这有助于阅读:

>&2 echo "error"

>&2将文件描述符#2复制到文件描述符#1。因此,执行此重定向后,两个文件描述符将引用同一个文件:最初引用的是一个文件描述符#2。有关更多信息,请参阅Bash Hackers Illustrated redirection Tutorial。

其他回答

这里有一个函数用于检查最后一个命令的退出状态,显示错误并终止脚本。

or_exit() {
    local exit_status=$?
    local message=$*

    if [ "$exit_status" -gt 0 ]
    then
        echo "$(date '+%F %T') [$(basename "$0" .sh)] [ERROR] $message" >&2
        exit "$exit_status"
    fi
}

用法:

gzip "$data_dir"
    or_exit "Cannot gzip $data_dir"

rm -rf "$junk"
    or_exit Cannot remove $junk folder

该函数打印脚本名称和日期,以便在从crontab调用脚本并记录错误时有用。

59 23 * * * /my/backup.sh 2>> /my/error.log

read是一个shell内置命令,可打印到stderr,可以像echo一样使用,而无需执行重定向技巧:

read -t 0.1 -p "This will be sent to stderr"

-t 0.1是一个超时,它禁用读取的主要功能,将一行stdin存储到变量中。

另一种选择

echo foo >>/dev/stderr

这是一个简单的STDERR函数,它将管道输入重定向到STDERR。

#!/bin/bash
# *************************************************************
# This function redirect the pipe input to STDERR.
#
# @param stream
# @return string
#
function STDERR () {

cat - 1>&2

}

# remove the directory /bubu
if rm /bubu 2>/dev/null; then
    echo "Bubu is gone."
else
    echo "Has anyone seen Bubu?" | STDERR
fi


# run the bubu.sh and redirect you output
tux@earth:~$ ./bubu.sh >/tmp/bubu.log 2>/tmp/bubu.err

我的建议:

echo "my errz" >> /proc/self/fd/2

or

echo "my errz" >> /dev/stderr

echo“myerrz”>/proc/self/fd/2将有效地输出到stderr,因为/proc/self是当前进程的链接,/proc/sell/fd保存进程打开的文件描述符,然后,0、1和2分别代表stdin、stdout和stderr。

/proc/self链接在MacOS上不起作用,但是,/proc/self/fd/*在Android上的Termux上可用,但在/dev/stderr上不可用。如何从Bash脚本检测操作系统?如果您需要通过确定要使用的变量来使脚本更具可移植性,可以提供帮助。